﻿using System;

namespace Korero.Chat
{
    public class Conversation : IEquatable<Conversation>
    {
        #region Public Enums, Properties and Fields

        public string Name { get; set; }

        public bool Seen { get; set; }

        #endregion

        #region Constructors, Destructors and Finalizers

        public Conversation(string name) : this()
        {
            Name = name;
        }

        public Conversation()
        {
        }

        #endregion

        #region Interface

        public bool Equals(Conversation other)
        {
            if (ReferenceEquals(null, other))
            {
                return false;
            }

            if (ReferenceEquals(this, other))
            {
                return true;
            }

            return Name == other.Name;
        }

        #endregion

        #region Public Overrides

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj))
            {
                return false;
            }

            if (ReferenceEquals(this, obj))
            {
                return true;
            }

            if (obj.GetType() != GetType())
            {
                return false;
            }

            return Equals((Conversation) obj);
        }

        public override int GetHashCode()
        {
            return Name != null ? Name.GetHashCode() : 0;
        }

        #endregion
    }
}