﻿using Korero.Database;

namespace Korero.Chat
{
    public class ConversationAvatar : Conversation
    {
        #region Public Enums, Properties and Fields

        public string FirstName => Name.Split(' ')[0];

        public string LastName => Name.Split(' ')[1];

        #endregion

        #region Constructors, Destructors and Finalizers

        public ConversationAvatar(string firstName, string lastName)
        {
            Name = $"{firstName} {lastName}";
        }

        public ConversationAvatar(DatabaseMessage databaseMessage)
        {
            Name = $"{databaseMessage.FirstName} {databaseMessage.LastName}";
        }

        public ConversationAvatar(string name)
        {
            Name = name;
        }

        public ConversationAvatar(string firstName, string lastName, int seen) : this(firstName, lastName)
        {
            Seen = seen == 1;
        }

        #endregion
    }
}