﻿using System.Collections.Generic;

namespace Korero.Communication
{
    public class Notification
    {
        #region Public Enums, Properties and Fields

        public string Type { get; }

        #endregion

        #region Private Delegates, Events, Enums, Properties, Indexers and Fields

        private readonly IReadOnlyDictionary<string, string> _notification;

        #endregion

        #region Constructors, Destructors and Finalizers

        public Notification(IReadOnlyDictionary<string, string> notification)
        {
            Type = notification["type"];

            _notification = notification;
        }

        #endregion

        #region Public Indexers

        public string this[string key] => _notification[key];

        #endregion
    }
}