﻿using System;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;

namespace Korero
{
    public static class Constants
    {
        #region Static Fields and Constants

        public const string DateTimeStamp = @"yyyy-MM-ddTHH:mm:ss.ffffffZ";

        public const int CommandTimeout = 60000;

        public static readonly string AssemblyName = Assembly.GetEntryAssembly().GetName().Name;

        public static readonly string AssemblyVersion = Assembly.GetEntryAssembly().GetName().Version.ToString();

        public static readonly string AssemblyGuid =
            ((GuidAttribute) Assembly.GetEntryAssembly().GetCustomAttributes(typeof(GuidAttribute), true)[0]).Value;

        #endregion

        #region Public Enums, Properties and Fields

        public static string UserApplicationDirectory => Path.Combine(
            Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments), @"Wizardry and Steamworks", @"Korero");

        #endregion
    }
}