﻿using System;

namespace Korero.Database
{
    public class DatabaseMessageGroup : DatabaseMessage, IEquatable<DatabaseMessageGroup>
    {
        #region Public Enums, Properties and Fields

        public string Group { get; }

        #endregion

        #region Constructors, Destructors and Finalizers

        public DatabaseMessageGroup(string firstName, string lastName, string message, DateTime time) : base(firstName,
            lastName, message, time)
        {
        }

        public DatabaseMessageGroup(string firstName, string lastName, string message, string group, DateTime time) :
            base(firstName, lastName, message, time)
        {
            Group = group;
        }

        #endregion

        #region Interface

        public bool Equals(DatabaseMessageGroup other)
        {
            if (ReferenceEquals(null, other))
            {
                return false;
            }

            if (ReferenceEquals(this, other))
            {
                return true;
            }

            return base.Equals(other) && Group == other.Group;
        }

        #endregion

        #region Public Overrides

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj))
            {
                return false;
            }

            if (ReferenceEquals(this, obj))
            {
                return true;
            }

            if (obj.GetType() != GetType())
            {
                return false;
            }

            return Equals((DatabaseMessageGroup) obj);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                return base.GetHashCode() * 397 ^ (Group != null ? Group.GetHashCode() : 0);
            }
        }

        #endregion
    }
}